// ========================== TEXT INTERFACE ======================== //
// Type: text				 							   //
// =================================================================== //

#ifndef _ITEXT_
#define _ITEXT_

#include <map>
#include <string>
#include <vector>

#include <string>
#include <gtk/gtk.h>

#include <gtksourceview/gtksourceview.h>
#include <gtksourceview/gtksourcelanguagemanager.h>

//sudo ln -s /usr/include/gtksourceview-2.0/gtksourceview/ /usr/include/gtksourceview


#include "gloobus-preview-interface-main.h"

using namespace std;

class iText : public interface
{
	protected:
    GtkTextBuffer 	*m_textbuf;
	GtkSourceBuffer *m_sBuf;
	
	
	public:
				virtual void			load		( void );
				virtual	int 			get_width	( void );
				virtual int 			get_height	( void );
				virtual	void			draw		( GtkContainer * container );
				virtual void			end			( void );
				void			draw_file_text	(GtkContainer * container); 
				void			draw_file_info	(GtkContainer * container);
		virtual GtkSourceBuffer*	get_textbuf ( void ) = 0;
	
	private:



};

//==============  CLASS FACTORIES DEFINITIONS================================= //
typedef iText* create_t_text ();									    //CREATE PLUGIN
typedef void destroy_t_text  (iText*);							   	//DESTROY PLUGIN
	
extern map<string, create_t_text *, less<string> > factory_text;		   //MAP WITH NAME AND CONSTRUCTOR
extern map<string, destroy_t_text *, less<string> > factoryDestroy_text;   //MAP WITH NAME AND DESTRUCTOR
extern vector<plugin_filetype> pluginVector;				   		 	   //VECTOR TO STORE WICH FILETYPE READ EACH PLUGIN

#endif
