#ifndef _IDEFAULT_
#define _IDEFAULT_

//#include <gtk/gtk.h>
#include <gio/gio.h>
#include <libgnomeui/libgnomeui.h>

#include "gloobus-preview-interface-image.h"

class iDefault : public iImage
{
	public:
	
	virtual 	GdkPixbuf*		get_pixbuf()  
	{				//WE MUST DEFINE HERE THE IMPLEMENTATION SINCE THERE IS A VTABLE ERROR
		
	/*	//BUSCAR THUMBNAIL
		GFileInfo * info = g_file_info_new	 ();
		info 			 = g_file_query_info ( m_gfile,  "*" ,G_FILE_QUERY_INFO_NONE, NULL , NULL);
		
		if(g_file_info_get_attribute_byte_string ( info, "thumbnail::path" ) == NULL) 
		{
			return get_icon();
		}
		else
		{
			string thumb = g_file_info_get_attribute_byte_string ( info, "thumbnail::path" );
			g_print("Thumbnail:%s\n",thumb.c_str());
			return gdk_pixbuf_new_from_file (thumb.c_str(),NULL);
		}


	return NULL;
*/

	GdkPixbuf * temp;
	g_print("Loading default...\n");
	GnomeThumbnailFactory * fac = gnome_thumbnail_factory_new(GNOME_THUMBNAIL_SIZE_LARGE);	

	string path = "file:///" + m_filename;
	//string path = g_filename_to_uri(m_filename.c_str(),NULL,NULL);
	//printf("URI::==== %s",path.c_str());

	if(gnome_thumbnail_factory_can_thumbnail(fac,path.c_str(),m_filetype.c_str(),NULL))
	{
		g_debug("Thumb ok\n");
		
	}
	else
	{
		g_warning("Thumb Fail\n");
	}

	temp = gnome_thumbnail_factory_generate_thumbnail(fac,path.c_str(),m_filetype.c_str());
	
	if(temp == NULL)			//There is no thumbnail, we load the default icon for the filetype
	{
		 return get_icon();
	}
	else
	{
		 return temp;
	}
 }

};



#endif


